jQuery(document).ready(function($) {
$('#spit_add').on('click', function() {
	var index = $('.spit_main .main-input').length;
	var markerWords = $('#spit-in').data('in');  
	var deleteText = $('.spit_del').data('del'); 
	var row = '<div class="main-input">' +
				'<div class="main-input-grid"><span><input placeholder="' + markerWords + '" type="text" name="spit_text[]" value=""></span>' +
				'<span class="tinymcenew"><textarea class="spit_content_editor" name="spit_content[]" id="spit_content_' + index + '"></textarea></span></div>' +
				'<span><button type="button" class="spit_del">' + deleteText + '</button></span>' +
			  '</div>';
	$('.spit_main').append(row);
	initializeEditors();
});
$('.spit_main').on('click', '.spit_del', function() {
	// Hủy bỏ TinyMCE instance cho textarea sẽ bị xóa
	var $textarea = $(this).closest('.main-input').find('textarea');
	$textarea.each(function() {
		var editor = tinymce.get($(this).attr('id'));
		if (editor) {
			editor.remove();
		}
	});
	// Xóa hàng
	$(this).closest('.main-input').remove();
});
function initializeEditors() {
	// Khởi tạo TinyMCE cho các textarea
	$('.spit_content_editor').each(function() {
		var $this = $(this);
		if (!tinymce.get($this.attr('id'))) {
			tinymce.init({
				selector: '#' + $this.attr('id'),
				menubar: false,
				plugins: 'link',
				toolbar: 'bold italic underline | link',
				forced_root_block: false,
				branding: false,
				valid_elements: 'a[href|target=_blank],strong/b,em/i,u,span[style],br',
				setup: function(editor) {
					editor.on('change', function() {
						editor.save();
					});
				}
			});
		}
	});
}
initializeEditors();
});