<?php
// add js css
function foxtips_enqueue_meta_assets() {
    wp_enqueue_script('foxtips-ad', FOXTIPS_URL . 'dir/admin.js', array('jquery'), FOXTIPS_VERSION, true);
	wp_enqueue_style('foxtips-ad', FOXTIPS_URL . 'dir/admin.css', FOXTIPS_VERSION);
}
add_action('admin_enqueue_scripts', 'foxtips_enqueue_meta_assets');
// Đăng ký metabox
function foxtips_textspit_metabox() {
    add_meta_box('textspit', esc_html__('Add dynamic popups to highlighted words in your articles', 'foxtips'), 'foxtips_textspit_render_metabox', 'post');
}
add_action('add_meta_boxes', 'foxtips_textspit_metabox');
// Hiển thị giao diện metabox
function foxtips_textspit_render_metabox($post) {
    $textspit = get_post_meta($post->ID, 'textspit', true);
    if (!$textspit) {
        $textspit = array();
    }
	if (function_exists('wc_get_products')) {
		$spit_product = get_post_meta( $post->ID, 'spit_product', true );
	}
    ?>
	<div class="spit_main">
		<?php if (function_exists('wc_get_products')) { ?>
			<div class="spit_main_tit"><?php esc_html_e('Highlight product title', 'foxtips'); ?></div>
			<div class="spit_main_product"><textarea placeholder="<?php esc_html_e('Enter a list of product titles', 'foxtips'); ?>" type="text" name="spit_product"><?php echo esc_textarea($spit_product); ?></textarea></div>
		<?php } ?>
		<div class="spit_main_tit"><?php esc_html_e('Highlight optional content', 'foxtips'); ?></div>
		<?php foreach ($textspit as $index => $data) { ?>
			<div class="main-input">
				<div class="main-input-grid">
				<span id="spit-in" data-in="<?php esc_html_e('Marker words', 'foxtips'); ?>"><input type="text" placeholder="<?php esc_html_e('Marker words', 'foxtips'); ?>" name="spit_text[]" value="<?php echo esc_attr($data['text']); ?>"></span>
				<span>
				<?php
				// Sử dụng wp_editor thay vì textarea
				$editor_id = 'spit_content_' . $index;
				wp_editor($data['content'], $editor_id, array(
					'textarea_name' => 'spit_content[]',
					'media_buttons' => false,
					'teeny' => true,
					'quicktags' => false,
					'textarea_rows' => 4,
					'tinymce' => array(
						'toolbar1' => 'bold italic underline | link',
						'toolbar2' => '',
						'plugins' => 'link',
						'forced_root_block' => false,
						'valid_elements' => 'a[href|target=_blank],strong/b,em/i,u,span[style],br',
					),
				));
				?>
				</span>
				</div>
				<span><button type="button" class="spit_del" data-del="<?php esc_html_e('Delete', 'foxtips'); ?>"><?php esc_html_e('Delete', 'foxtips'); ?></button></span>
			</div>
	<?php } ?>
	</div>
	<button type="button" id="spit_add"><?php esc_html_e('Add new words', 'foxtips'); ?></button>
<?php
}
// Lưu dữ liệu khi bài viết được lưu
function foxtips_textspit_custom_metabox($post_id) {
    if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) return;
    if (!current_user_can('edit_post', $post_id)) return;
    $textspit = array();
    if (isset($_POST['spit_text'])) {
        $spit_texts = $_POST['spit_text'];
        $spit_contents = $_POST['spit_content'];
        foreach ($spit_texts as $index => $text) {
            if (!empty($text)) {
                $textspit[] = array(
                    'text' => sanitize_text_field($text),
                    'content' => wp_kses_post($spit_contents[$index]),
                );
            }
        }
    }
    update_post_meta($post_id, 'textspit', $textspit);
	if (function_exists('wc_get_products')) {
		if(isset($_POST['spit_product'])){
			update_post_meta( $post_id, 'spit_product', sanitize_textarea_field( $_POST['spit_product'] ));
		}
	}
}
add_action('save_post', 'foxtips_textspit_custom_metabox');
// text to the content
function foxtips_insert_textspit_in_content($content) {
	if (is_single() && 'post' === get_post_type()) {
		global $post;
		$textspit = get_post_meta($post->ID, 'textspit', true);

		if (!empty($textspit)) {
			// Tạo mảng từ khóa để thay thế
			$keywords = array_column($textspit, 'text');

			// Tách nội dung bài viết theo các thẻ HTML
			$parts = preg_split('/(<[^>]+>)/', $content, -1, PREG_SPLIT_DELIM_CAPTURE);

			// Thay thế từ khóa chỉ trong các đoạn văn bản không phải là thẻ HTML
			foreach ($parts as &$part) {
				// Kiểm tra nếu đoạn không phải là thẻ HTML
				if (strpos($part, '<') === false) {
					// Thực hiện thay thế các từ khóa bằng <span>
					$part = preg_replace_callback(
						'/(' . implode('|', array_map('preg_quote', $keywords)) . ')/',
						function ($matches) use ($textspit) {
							foreach ($textspit as $spit) {
								if ($matches[0] === $spit['text']) {
									$text = esc_html($spit['text']);
									$content_str = wp_kses_post($spit['content']);
									// Thêm từ khóa vào thẻ <span> với thuộc tính data-content
									$span_text = '<span class="foxtips-text" data-content="' . esc_attr($content_str) . '">' . $text . '</span>';
									return $span_text;
								}
							}
							return $matches[0];
						},
						$part
					);
				}
			}
			// Ghép lại các đoạn đã thay thế với các thẻ HTML
			$content = implode('', $parts);
		}
		return $content;
	}
	return $content;
}
add_filter('the_content', 'foxtips_insert_textspit_in_content');
// product to the content
function foxtips_insert_specific_product_links_in_content($content) {
	if (is_single() && 'post' === get_post_type()) {
		if (!function_exists('wc_get_products')) {
			return $content;
		}

		$listau = get_post_meta(get_the_ID(), 'spit_product', true);
		$keywords = explode("\n", str_replace("\r", "", $listau));
		$product_links = [];

		// Lặp qua các từ khóa để tìm sản phẩm và tạo liên kết
		foreach ($keywords as $keyword) {
			$args = [
				'post_type' => 'product',
				'post_status' => 'publish',
				'posts_per_page' => 1,
				's' => $keyword,
			];

			$query = new WP_Query($args);
			if ($query->have_posts()) {
				while ($query->have_posts()) {
					$query->the_post();
					$product_id = get_the_ID();
					$product = wc_get_product($product_id);

					// Xử lý biến thể sản phẩm
					if ($product->is_type('variable')) {
						$prices = $product->get_variation_prices(true);
						$min_price = current($prices['price']);
						$max_price = end($prices['price']);
					} else {
						$min_price = $product->get_price();
						$max_price = $min_price;
					}

					// Thiết lập giá sản phẩm
					$price_range = ($min_price == $max_price) ? wc_price($min_price) : wc_price($min_price) . ' - ' . wc_price($max_price);

					$thumbnail_url = get_the_post_thumbnail_url($product_id, 'thumbnail');
					$add_to_cart_url = esc_url(add_query_arg('add-to-cart', $product_id, get_permalink($product_id)));
					$add_to_cart_button = '<a href="' . $add_to_cart_url . '" class="spin_add">' . esc_html__('Buy now', 'foxtips') . '</a>';

					$product_links[] = [
						'title' => get_the_title(),
						'url' => get_permalink(),
						'content' => $thumbnail_url,
						'price' => $price_range,
						'add' => $add_to_cart_button,
					];
				}
				wp_reset_postdata();
			}
		}

		if (empty($product_links)) {
			error_log("No product links were generated.");
		}

		// Tách nội dung bài viết theo các thẻ HTML
		$parts = preg_split('/(<[^>]+>)/', $content, -1, PREG_SPLIT_DELIM_CAPTURE);

		// Lặp qua từng phần của nội dung
		foreach ($parts as &$part) {
			// Chỉ thay thế từ khóa trong các đoạn văn bản (không phải là thẻ HTML)
			if (strpos($part, '<') === false) {
				$part = preg_replace_callback(
					'/(' . implode('|', array_map('preg_quote', array_column($product_links, 'title'))) . ')/',
					function ($matches) use ($product_links) {
						foreach ($product_links as $link) {
							if ($matches[0] === $link['title']) {
								$title = esc_html($link['title']);
								$url = esc_url($link['url']);
								$thumbnail = '<img src="' . esc_attr($link['content']) . '" />';
								$price = $link['price'];
								$add_to_cart_button = $link['add'];

								// Tạo nội dung tooltip
								$tooltip_content = '<a class="spit_tit" href="' . $url . '">' . $thumbnail . ' ' . $title . '</a><br>' . $price . '<br>' . $add_to_cart_button;

								// Thay thế từ khóa bằng <span> với tooltip
								$span_text = '<span class="foxtips-text foxtips-product" data-content="' . esc_attr($tooltip_content) . '">' . $title . '</span>';
								return $span_text;
							}
						}
						return $matches[0];
					},
					$part
				);
			}
		}

		// Ghép lại nội dung đã thay thế với các thẻ HTML ban đầu
		$content = implode('', $parts);
		return $content;
	}
	return $content;
}
add_filter('the_content', 'foxtips_insert_specific_product_links_in_content');


